--[[
*****************************************************************
*
* Licensed Materials - Property of IBM
*
* (C) Copyright IBM Corp. 2016, 2017. All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*
*****************************************************************]]

ffi = require 'ffi'

cmd = torch.CmdLine()

cmd:option('-data', './imagenet/imagenet_raw_images/256', 'Location of LMDB')

opt = cmd:parse(arg or {})


runThreads = 1
nthreads = 2
njobs = 20
--opt = {}
opt.batchSize = 1024
opt.cropSize = 224
print(opt.data)
print("Batch Size " .. opt.batchSize)
print("Number of threads " .. nthreads)
print("Number of jobs " .. njobs)

IO = require 'torchio'
torchio = IO.torchio(opt.data, 123)

torchio:init(opt.data,1e6)
inp,lab = torchio:sampleLMDB(opt.batchSize,opt.cropSize)

torchio:close()

if runThreads == 1 then
  collectgarbage()
  local Threads = require 'threads'
  Threads.serialization('threads.sharedserialize')
  local options = opt;
  donkeys = Threads(nthreads,
              function()
                opt = options
                IO = require 'torchio'
              end,
             function()
             torchio = IO.torchio(opt.data, 123)
             torchio:init(opt.data,1e6)
             end
              )
--[[
   donkeys:specific(true)
   for i=1,opt.nDonkeys do
      donkeys:addjob(i,
         function()
          end,
           function() end)
     donkeys:synchronize()
   end
   donkeys:specific(false)
   donkeys:synchronize()
--]]
local ttm = torch.Timer()
  ttm:reset()
  for i=1,njobs do
    print("Starting process " .. i)
    donkeys:addjob(
    function()
           inputs,labels = torchio:sampleLMDB(opt.batchSize,opt.cropSize)
            return inputs, labels
    end,
     function(a,b)
       collectgarbage()
    end)
  end
  donkeys:synchronize()
  print("Elapsed time " .. ttm:time().real / njobs)
   donkeys:specific(true)
   for i=1,nthreads do
      donkeys:addjob(i,
         function()
              torchio:close()
          end,
           function() end)
     donkeys:synchronize()
   end
   donkeys:specific(false)
   donkeys:synchronize()
end
collectgarbage()


