# Contributing to iTorch
We want to make contributing to this project as easy and transparent as
possible.

## Our Development Process
iTorch is not big enough that we have a standard development process.  
We follow the [Torch-7](https://github.com/torch/torch7/blob/master/CONTRIBUTING.md) development process loosely.

## Pull Requests
We actively welcome your pull requests.

1. Fork the repo and create your branch from `master`. 
2. If you've added code that should be tested, add tests
3. If you've changed APIs, update the documentation. 
4. Ensure the test suite passes. 
5. Make sure your code lints. 
6. If you haven't already, complete the Contributor License Agreement ("CLA").

## Contributor License Agreement ("CLA")
In order to accept your pull request, we need you to submit a CLA. You only need
to do this once to work on any of Facebook's open source projects.

Complete your CLA here: <https://code.facebook.com/cla>

## Issues  
We use GitHub issues to track public bugs. Please ensure your description is
clear and has sufficient instructions to be able to reproduce the issue.

## Coding Style  
* 2 spaces for indentation rather than tabs
* 80 character line length

## License
By contributing to iTorch, you agree that your contributions will be licensed
under its BSD license.