
ffi = require 'ffi'

M = {}

cls = torch.class('torchio',M)
-- 2504 mrand 24 lrand
ffi.cdef[[

   typedef struct MDB_env MDB_env;
   typedef struct {
      MDB_env *env;
      long int nentries;
   char seed[2504];
   char seedT[2][2504];
    int seedSet;
   } lmdbEnv;
   typedef lmdbEnv * lmdbEnv_p;

  bool sampleLMDB_t(float * inp, long int * lab, lmdbEnv * l_env, int batchSize, int cropSize);
   bool setseed(lmdbEnv * env,int seed);
   bool initLMDB(lmdbEnv * env, char * filename, long int seed, long int ps);
   bool initLMDBCreate(lmdbEnv * env, char * filename);
   bool insertLMDB_t(lmdbEnv * l_env, char * image_filename, int label,int indx);
   bool blockLMDB_t(float * batch, long int * lab, lmdbEnv * l_env, int batchSize, int cropSize,long int start);
   
   bool closeLMDB(lmdbEnv * env);  

]]
sample =  ffi.load('libtorchio.so')

function cls:__init(lmdb_file_name,seed,ps,bs,cropsize,mode)

    M.lmdb_env = ffi.new("lmdbEnv")
    M.mode = mode
    sample.setseed(ffi.cast("lmdbEnv_p",M.lmdb_env),seed)
end

function cls:init(str,ps)
   c_str = ffi.new("char[?]", #str+1)
    ffi.copy(c_str, str,#str)

    print("torchio:Init")
    if (M.mode == 'create') then 
      ret = sample.initLMDBCreate(ffi.cast("lmdbEnv_p",M.lmdb_env),c_str)
      assert(ret)
    else
      ret = sample.initLMDB(ffi.cast("lmdbEnv_p",M.lmdb_env),c_str,100,ps)
      assert(ret)
    end
end


function cls:close()
  print("torchio:Close")
  sample.closeLMDB(ffi.cast("lmdbEnv_p",M.lmdb_env))
end

function cls:sampleLMDB(bs,cropsize)
  local bs = bs or M.bs
  local cropsize = cropsize or M.cropsize
  local inputs = torch.FloatTensor(bs,3,cropsize,cropsize)
  local labels = torch.LongTensor(bs)
  sample.sampleLMDB_t(inputs:data(),labels:data(),ffi.cast("lmdbEnv_p",M.lmdb_env),bs, cropsize)
  return inputs,labels
end

function cls:blockLMDB(bs,cropsize,start)
  local bs = bs or M.bs
  local cropsize = cropsize or M.cropsize
  local inputs = torch.FloatTensor(bs,3,cropsize,cropsize)
  local labels = torch.LongTensor(bs)
  sample.blockLMDB_t(inputs:data(),labels:data(),ffi.cast("lmdbEnv_p",M.lmdb_env),bs, cropsize,start)
  return inputs,labels
end



function cls:insertLMDB(imagename,label,indx)
    c_str = ffi.new("char[?]", #imagename+1)
    ffi.copy(c_str, imagename,#imagename)
    sample.insertLMDB_t(ffi.cast("lmdbEnv_p",M.lmdb_env),c_str,label,indx);
    --sample.insertLMDB_t(ffi.cast("lmdbEnv_p",M.lmdb_env),image_file_name);
end

return M

